



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>spark使用总结</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">spark使用总结</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-31 10:53:53 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>背景</strong></p>
<p>使用spark开发已有几个月。相比于python/hive，scala/spark学习门槛较高。尤其记得刚开时，举步维艰，进展十分缓慢。不过谢天谢地，这段苦涩（bi）的日子过去了。忆苦思甜，为了避免项目组的其他同学走弯路，决定总结和梳理spark的使用经验。</p>
<p><strong>Spark基础</strong></p>
<p>基石RDD</p>
<p>spark的核心是RDD（弹性分布式数据集），一种通用的数据抽象，封装了基础的数据操作，如map，filter，reduce等。RDD提供<strong>数据共享</strong>的抽象，相比其他大数据处理框架，如MapReduce，Pegel，DryadLINQ和HIVE等均缺乏此特性，所以RDD更为通用。</p>
<p>简要地概括RDD：RDD是一个不可修改的，分布的对象集合。每个RDD由多个分区组成，每个分区可以同时在集群中的不同节点上计算。RDD可以包含Python，Java和Scala中的任意对象。</p>
<p>Spark生态圈中应用都是基于RDD构建（下图），这一点充分说明RDD的抽象足够通用，可以描述大多数应用场景。</p>
<p><img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/689069/201511/689069-20151130182924530-1968348238.jpg"></p>
<p>RDD操作类型—转换和动作</p>
<p>RDD的操作主要分两类：转换（transformation）和动作（action）。两类函数的主要区别是，转换接受RDD并返回RDD，而动作接受RDD但是返回非RDD。转换采用惰性调用机制，每个RDD记录父RDD转换的方法，这种调用链表称之为血缘（lineage）；而动作调用会直接计算。</p>
<p>采用惰性调用，通过血缘连接的RDD操作可以管道化（pipeline），管道化的操作可以直接在单节点完成，避免<strong>多次转换操作之间数据同步的等待</strong>。</p>
<p>使用血缘串联的操作可以保持每次计算相对简单，而不用担心有过多的中间数据，因为这些血缘操作都管道化了，这样也保证了逻辑的单一性，而不用像MapReduce那样，为了竟可能的减少map reduce过程，在单个map reduce中写入过多复杂的逻辑。</p>
<p><img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/689069/201511/689069-20151130182925374-984828461.png"></p>
<p>RDD使用模式</p>
<p>RDD使用具有一般的模式，可以抽象为下面的几步</p>
<ol><li><div>加载外部数据，创建RDD对象</div></li>
<li><div>使用转换（如filter），创建新的RDD对象</div></li>
<li><div>缓存需要重用的RDD</div></li>
<li><div>使用动作（如count），启动并行计算</div></li></ol>
<p>RDD高效的策略</p>
<p>Spark官方提供的数据是RDD在某些场景下，计算效率是Hadoop的20X。这个数据是否有水分，我们先不追究，但是RDD效率高的由一定机制保证的：</p>
<ol><li><div>RDD数据只读，不可修改。如果需要修改数据，必须从父RDD转换（transformation）到子RDD。所以，在容错策略中，<strong>RDD没有数据冗余</strong>，而是通过RDD父子依赖（血缘）关系进行重算实现容错。</div></li>
<li><div>RDD数据在内存中，多个RDD操作之间，数据不用落地到磁盘上，避免不必要的I/O操作。</div></li>
<li><div>RDD存放的数据可以是java对象，所以避免的不必要的对象序列化和反序列化。</div></li></ol>
<p>总而言之，RDD高效的主要因素是尽量避免不必要的操作和牺牲数据的操作精度，用来提高计算效率。</p>
<p><strong>Spark使用技巧</strong></p>
<p>RDD操作闭包外部变量原则</p>
<p><img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/689069/201511/689069-20151130182926483-355885422.png"></p>
<p>RDD相关操作都需要传入自定义闭包函数（closure），如果这个函数需要访问外部变量，那么需要遵循一定的规则，否则会抛出运行时异常。闭包函数传入到节点时，需要经过下面的步骤：</p>
<ol><li>驱动程序，通过反射，运行时找到闭包访问的所有变量，并封成一个对象，然后序列化该对象</li>
<li>将序列化后的对象通过网络传输到worker节点</li>
<li>worker节点反序列化闭包对象</li>
<li>worker节点执行闭包函数，</li></ol>
<p>注意：外部变量在闭包内的修改<strong>不会被反馈</strong>到驱动程序。</p>
<p>简而言之，就是通过网络，传递函数，然后执行。所以，被传递的变量必须可以<strong>序列化</strong>，否则传递失败。本地执行时，仍然会执行上面四步。</p>
<p>广播机制也可以做到这一点，但是频繁的使用广播会使代码不够简洁，而且广播设计的初衷是将较大数据缓存到节点上，避免多次数据传输，提高计算效率，而不是用于进行外部变量访问。</p>
<p>RDD数据同步</p>
<p>RDD目前提供两个数据同步的方法：广播和累计器。</p>
<p><strong>广播 broadcast</strong></p>
<p>前面提到过，广播可以将变量发送到闭包中，被闭包使用。但是，广播还有一个作用是同步较大数据。比如你有一个IP库，可能有几G，在map操作中，依赖这个ip库。那么，可以通过广播将这个ip库传到闭包中，被并行的任务应用。广播通过两个方面提高数据共享效率：1，集群中每个节点（物理机器）只有一个副本，默认的闭包是每个任务一个副本；2，广播传输是通过BT下载模式实现的，也就是P2P下载，在集群多的情况下，可以极大的提高数据传输速率。广播变量修改后，不会反馈到其他节点。</p>
<p><strong>累加器 Accumulator</strong></p>
<p>累加器是一个write-only的变量，用于累加各个任务中的状态，只有在驱动程序中，才能访问累加器。而且，截止到1.2版本，累加器有一个已知的缺陷，在action操作中，n个元素的RDD可以确保累加器只累加n次，但是在transformation时，spark不确保，也就是累加器可能出现n+1次累加。</p>
<p>目前RDD提供的同步机制粒度太粗，尤其是转换操作中变量状态不能同步，所以RDD无法做复杂的具有状态的事务操作。不过，RDD的使命是提供一个通用的并行计算框架，估计永远也不会提供细粒度的数据同步机制，因为这与其设计的初衷是违背的。</p>
<p>RDD优化技巧</p>
<p><strong>RDD缓存</strong></p>
<p>需要使用多次的数据需要cache，否则会进行不必要的重复操作。举个例子</p>
<div>
<table>
<tbody>
<tr>
<td>
<p>val data = … // read from tdw</p>
<p>println(data.filter(_.contains("error")).count)</p>
<p>println(data.filter(_.contains("warning")).count)</p>
</td>
</tr>
</tbody>
</table>
</div>
<p>上面三段代码中，data变量会加载两次，高效的做法是在data加载完后，立刻持久化到内存中，如下</p>
<div>
<table>
<tbody>
<tr>
<td>
<p>val data = … // read from tdw</p>
<p>data.cache</p>
<p>println(data.filter(_.contains("error")).count)</p>
<p>println(data.filter(_.contains("warning")).count)</p>
</td>
</tr>
</tbody>
</table>
</div>
<p>这样，data在第一加载后，就被缓存到内存中，后面两次操作均直接使用内存中的数据。</p>
<p><strong>转换并行化</strong></p>
<p>RDD的转换操作时并行化计算的，但是多个RDD的转换同样是可以并行的，参考如下</p>
<div>
<table>
<tbody>
<tr>
<td>
<p>val dataList:Array[RDD[Int]] = …</p>
<p>val sumList = data.list.map(_.map(_.sum))</p>
</td>
</tr>
</tbody>
</table>
</div>
<p>上面的例子中，第一个map是便利Array变量，串行的计算每个RDD中的每行的sum。由于每个RDD之间计算是没有逻辑联系的，所以理论上是可以将RDD的计算并行化的，在scala中可以轻松试下，如下</p>
<div>
<table>
<tbody>
<tr>
<td>
<p>val dataList:Array[RDD[Int]] = …</p>
<p>val sumList = data.list.par.map(_.map(_.sum))</p>
</td>
</tr>
</tbody>
</table>
</div>
<p>注意红色代码。</p>
<p><strong>减少shuffle网络传输</strong></p>
<p>一般而言，网络I/O开销是很大的，减少网络开销，可以显著加快计算效率。任意两个RDD的shuffle操作（join等）的大致过程如下，</p>
<p><img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/689069/201511/689069-20151130182927483-372069237.png"></p>
<p>用户数据userData和事件events数据通过用户id连接，那么会在网络中传到另外一个节点，这个过程中，有两个网络传输过程。Spark的默认是完成这两个过程。但是，如果你多告诉spark一些信息，spark可以优化，只执行一个网络传输。可以通过使用、HashPartition，在userData"本地"先分区，然后要求events直接shuffle到userData的节点上，那么就减少了一部分网络传输，减少后的效果如下，</p>
<p><img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/689069/201511/689069-20151130182928218-398349039.png"></p>
<p>虚线部分都是在本地完成的，没有网络传输。在数据加载时，就按照key进行partition，这样可以经一部的减少本地的HashPartition的过程，示例代码如下</p>
<div>
<table>
<tbody>
<tr>
<td>
<p>val userData = sc.sequenceFile[UserID, UserInfo]("hdfs://…")</p>
<p>.partitionBy(new HashPartitioner(100)) // Create 100 partitions</p>
<p>.persist()</p>
</td>
</tr>
</tbody>
</table>
</div>
<p>注意，上面一定要persist，否则会重复计算多次。100用来指定并行数量。</p>
<p><strong>Spark其他</strong></p>
<p>Spark开发模式</p>
<p>由于spark应用程序是需要在部署到集群上运行的，导致本地调试比较麻烦，所以经过这段时间的经验累积，总结了一套开发流程，目的是为了尽可能的提高开发调试效率，同时保证开发质量。当然，这套流程可能也不是最优的，后面需要持续改进。</p>
<p><img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/689069/201511/689069-20151130182928718-1500261048.png"></p>
<p>整个流程比较清楚，这里主要谈谈为什么需要单元测试。公司内的大多数项目，一般不提倡单元测试，而且由于项目进度压力，开发人员会非常抵触单元测试，因为会花费"额外"的精力。Bug这东西不会因为项目赶进度而消失，而且恰好相反，可能因为赶进度，而高于平均水平。所以，如果不花时间进行单元测试，那么会花同样多，甚至更多的时间调试。很多时候，往往一些很小的bug，却导致你花了很长时间去调试，而这些bug，恰好是很容易在单元测试中发现的。而且，单元测试还可以带来两个额外的好处：1）API使用范例；2）回归测试。所以，还是单元测试吧，这是一笔投资，而且ROI还挺高！不过凡事需要掌握分寸，单元测试应该根据项目紧迫程度调整粒度，做到有所为，有所不为。</p>
<p>Spark其他功能</p>
<p>前面提到了spark生态圈，spark除了核心的RDD，还提供了之上的几个很使用的应用：</p>
<ol><li><div>Spark SQL: 类似hive，使用rdd实现sql查询</div></li>
<li><div>Spark Streaming: 流式计算，提供实时计算功能，类似storm</div></li>
<li><div>MLLib：机器学习库，提供常用分类，聚类，回归，交叉检验等机器学习算法并行实现。</div></li>
<li><div>GraphX：图计算框架，实现了基本的图计算功能，常用图算法和pregel图编程框架。</div></li></ol>
<p>后面需要继续学习和使用上面的功能，尤其是与数据挖掘强相关的MLLib。</p>
<div>来源：&nbsp;&lt;<a href="http://www.cnblogs.com/bourneli/p/4394271.html" rel="external nofollow noreferrer">http://www.cnblogs.com/bourneli/p/4394271.html</a>&gt;</div>

<div><a href="http://www.wiz.cn/i/1fe9367f" rel="external nofollow noreferrer">来自为知笔记(Wiz)</a></div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/wq1zg259.html">Nacl开发</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8e4wpm9.html">Java易混淆的概率：成员变量、类变量、实例变量、局部变量</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8koy05q.html">cosbench 异常 FreeMarker template error&colon; The following has evaluated to null or missing</a>
		</li>
						<li><a href="https://www.batexi.com/a/m965j3jq.html">&lbrack;转&rsqb;Meta http-equiv属性详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/90ved6j8.html">1&period;5 理解Analyzers&comma;Tokenizers&comma;Filters--目录</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjmwoj8.html">Binary Tree（二叉树&plus;思维）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zdwp09.html">InnoDB关键特性之刷新邻接页-异步IO</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljw3219.html">Java并发之CyclicBarrier、CountDownLatch、Phaser</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jnx2v8.html">web1 - HTML&amp;amp&semi;CSS</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdp2ov7q.html">Oracle硬解析，软解析，软软解析介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwedk79.html">Tecplot&colon; 多截面云图显示</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdlwnj9.html">IIS6下使用多域名和通配符证书</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwkvnk8.html">Bitcoin Core钱包客户端的区块数据搬家指南</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1r4ry58.html">gitlab-ci &plus; k8s 之gitlab-ci（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvnk1l8.html">postman&lpar;一&rpar;：主界面模块解析</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyek539.html">container injection&mdash;&mdash;容器技术</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2zpypq.html">【JVM&period;3】虚拟机性能监控与故障处理工具</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4l75k9.html">imageio&period;ffmpeg&period;download&lpar;&rpar; has been deprecated&period; Use &amp;&num;39&semi;pip install im ageio-ffmpeg&amp;&num;39&semi; instead&period;&amp;&num;39&semi;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o4k43lq.html">各种蕴含算法思想的DP - 3</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ko63djq.html">&period;net asp &lbrack;转载&rsqb;ASP&colon;循环滚动图片的代码&plus;解释</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8ojdm4xq.html">css单独设定样式</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdp57kxq.html">php源码分析之base64&lowbar;encode函数</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy12zpgq.html">lpr</a>
			</li>
						<li><a href="https://www.batexi.com/a/950p4x68.html">Android的Activity跳转动画各种效果整理</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pdm0l49.html">【简单dp】 poj 2346</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rg4ol78.html">apache2&period;2&period;25&plus;mod&lowbar;jk-apache-2&period;2&period;2&period;so&plus;apache-tomcat-7&period;0&period;56集群</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jzey448.html">python 打印类的属性、方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ey5eoz9.html">c&num;如何序列化与反序列化json文件</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv1zvyxq.html">mariadb cache</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7zlmre9.html">prologue  epilogue</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
